## pure-0.67.tar.gz

=== examples/bitcode/Makefile ===

# GNU Makefile to compile the C, Fortran and Faust examples to LLVM bitcode.

# Edit these as needed. CC is the C compiler, FC the Fortran compiler, FAUST
# the Faust compiler, including any options for LLVM bitcode generation that
# they may need.

# NOTE: When using the dragonegg plugin for gcc, make sure to set the variable
# below to the actual pathname of the plugin on your system. Also note that at
# present dragonegg can't be used with -c to generate LLVM bitcode directly
# from source files. Therefore the Makefile selects a different sets of rules
# which create the bitcode from intermediate LLVM assembler (.ll) files
# instead.

# This should work out of the box if you installed dragonegg on ggc's plugin
# path (gcc -print-file-name=plugin).
dragonegg=dragonegg

# Note that dragonegg hasn't been ported to gcc versions >= 4.9 yet, so we
# currently use clang for C compilation by default. If you're still running an
# older version of gcc+dragonegg instead of clang then change the CC lines
# below accordingly.

#CC = llvm-gcc -emit-llvm
#CC = gcc -fplugin=dragonegg -flto
CC = clang -emit-llvm
#FC = llvm-gfortran -emit-llvm
FC = gfortran -fplugin=dragonegg -flto
FAUST = faust -double -lang llvm

# Where the LLVM toolchain (llvm-as et al) is located:
LLVMBIN = $(shell pkg-config pure --variable tool_prefix)

# Prerequisites:

# For the C and Fortran examples, you need to have a version of llvm-gcc or
# gcc+dragonegg with both C and Fortran support installed. (Clang can be used
# instead of llvm-gcc if you have it.) Also, the headers and libraries of the
# GNU Scientific Library (GSL) are needed to compile and run the gslsort.c
# example.

# For the Faust signal processing examples (.dsp programs), you'll need a
# special version of Grame's Faust compiler (http://faust.grame.fr). Until
# Faust's new LLVM backend becomes part of the mainline Faust compiler, you
# can find this on the special 'faust2' branch in Faust's git repository at:
# git://faudiostream.git.sourceforge.net/gitroot/faudiostream/faudiostream

# If your system lacks any of the above then some of the examples will refuse
# to build. Compilation will proceed anyway, so that you should be able to
# build at least the examples for which you have the required utilities.

# Usage:

# 'make' compiles all the examples.

# 'make asm' can be used to generate the LLVM assembler code for the examples.
# (These are for your own perusal, they aren't needed for running the examples
# in Pure.)

# 'make clean' removes all the generated bitcode and assembler files.

# Examples showing how to use the bitcode interface in Pure 0.44 and later can
# be found in the corresponding *.pure scripts.

c_source   := $(wildcard *.c)
# f_source disabled for now, as neither llvm-gcc and dragonegg is supported
# any longer, so at present we're left without an LLVM-capable Fortran
# compiler that we could use. :(
#f_source   := $(wildcard *.f90)
dsp_source := $(wildcard *.dsp)
bitcode    := $(c_source:.c=.bc) $(f_source:.f90=.bc) $(dsp_source:.dsp=.bc)
assembler  := $(c_source:.c=.ll) $(f_source:.f90=.ll) $(dsp_source:.dsp=.ll)
source     := $(c_source) $(f_source) $(dsp_source)

all: $(bitcode)

asm: $(assembler)

clean:
	-rm -f $(bitcode)
	-rm -f $(assembler)

# direct rules to generate LLVM bitcode (these don't work with dragonegg)

ifeq (,$(findstring $(dragonegg),$(CC)))
%.bc: %.c
	-$(CC) -c $< -o $@
endif

ifeq (,$(findstring $(dragonegg),$(FC)))
%.bc: %.f90
	-$(FC) -c $< -o $@
endif

%.bc: %.dsp
	-$(FAUST) $< -o $@

# fallback rule to generate LLVM bitcode from assembler
%.bc: %.ll
	-$(LLVMBIN)llvm-as $< -o $@

# compile C source to LLVM assembler
%.ll: %.c
	-$(CC) -S $< -o $@

# compile Fortran source to LLVM assembler
%.ll: %.f90
	-$(FC) -S $< -o $@

# compile Faust source to LLVM assembler
%.ll: %.dsp
	-$(FAUST) $< > $@

=== debian/changelog ===
pure (0.67-1) bionic; urgency=medium

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Sun, 18 Mar 2018 07:55:00 +0100

pure (0.66-4) bionic; urgency=medium

  * Add missing build dependency: elpa-flycheck

 -- Albert Graef <aggraef@gmail.com>  Sun, 18 Mar 2018 06:17:59 +0100

pure (0.66-3) bionic; urgency=medium

  * Latest upstream changes (flycheck support)

 -- Albert Graef <aggraef@gmail.com>  Sun, 18 Mar 2018 00:27:51 +0100

pure (0.66-2) artful; urgency=medium

  * Rebuild for Artful, minor packaging fixes

 -- Albert Graef <aggraef@gmail.com>  Mon, 11 Dec 2017 11:25:30 +0100

pure (0.66-1) xenial; urgency=medium

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Sat, 04 Mar 2017 21:33:47 +0100

pure (0.65-1) xenial; urgency=medium

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Thu, 23 Feb 2017 23:01:17 +0100

pure (0.64-5) xenial; urgency=medium

  * Remove texmacs-common from the dependencies of pure-texmacs, as
    TeXmacs is not in the standard repositories any more

 -- Albert Graef <aggraef@gmail.com>  Sun, 05 Jun 2016 21:39:09 +0200

pure (0.64-4) xenial; urgency=medium

  * Ubuntu 16.04 compatibility

 -- Albert Graef <aggraef@gmail.com>  Sun, 05 Jun 2016 08:49:31 +0200

pure (0.64-3) trusty; urgency=low

  * Upstream bugfixes

 -- Albert Graef <aggraef@gmail.com>  Sun, 09 Nov 2014 16:36:24 +0100

pure (0.64-2) trusty; urgency=low

  * Upstream bugfixes

 -- Albert Graef <aggraef@gmail.com>  Thu, 30 Oct 2014 15:27:51 +0100

pure (0.64-1) trusty; urgency=low

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Tue, 28 Oct 2014 22:41:46 +0100

pure (0.63-1) trusty; urgency=low

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Wed, 22 Oct 2014 16:41:26 +0200

pure (0.62-2) trusty; urgency=low

  * Upstream bugfixes

 -- Albert Graef <aggraef@gmail.com>  Tue, 23 Sep 2014 06:54:29 +0200

pure (0.62-1) trusty; urgency=low

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Wed, 17 Sep 2014 00:13:12 +0200

pure (0.61-6) trusty; urgency=low

  * Upstream bugfixes

 -- Albert Graef <aggraef@gmail.com>  Mon, 15 Sep 2014 22:52:16 +0200

pure (0.61-5) trusty; urgency=low

  * Upstream: experimental code generation options (-m)

 -- Albert Graef <aggraef@gmail.com>  Mon, 15 Sep 2014 00:20:55 +0200

pure (0.61-4) trusty; urgency=low

  * Add dependencies for the new pure-avahi, pure-lilv and pure-lv2
    packages to the pure-util and pure-multimedia meta packages

 -- Albert Graef <aggraef@gmail.com>  Sun, 14 Sep 2014 20:42:48 +0200

pure (0.61-3) trusty; urgency=low

  * Remove dependency on pure-gnumeric due to missing development files

 -- Albert Graef <aggraef@gmail.com>  Sat, 13 Sep 2014 23:25:50 +0200

pure (0.61-2) trusty; urgency=low

  * Add missing pkg-config dependency to pure-dev package

 -- Albert Graef <aggraef@gmail.com>  Fri, 12 Sep 2014 13:31:29 +0200

pure (0.61-1) trusty; urgency=low

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Fri, 12 Sep 2014 10:38:22 +0200

pure (0.58-1) precise; urgency=low

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Tue, 17 Sep 2013 00:19:07 +0200

pure (0.57-2) precise; urgency=low

  * Maintainer email change, bugfixes

 -- Albert Graef <aggraef@gmail.com>  Fri, 24 May 2013 05:31:36 +0200

pure (0.57-1) precise; urgency=low

  * New upstream release

 -- Albert Graef <Dr.Graef@t-online.de>  Thu, 14 Feb 2013 17:21:30 +0100

pure (0.56-7) precise; urgency=low

  * Linker fixes

 -- Albert Graef <Dr.Graef@t-online.de>  Fri, 18 Jan 2013 05:23:32 +0100

pure (0.56-6) natty; urgency=low

  * Faust2 compatibility fixes

 -- Albert Graef <Dr.Graef@t-online.de>  Tue, 15 Jan 2013 21:33:38 +0100

pure (0.56-5) natty; urgency=low

  * Add pure-reduce to the pure-math meta package

 -- Albert Graef <Dr.Graef@t-online.de>  Tue, 04 Dec 2012 15:00:58 +0100

pure (0.56-4) natty; urgency=low

  * Post-release fixes to TeXmacs plugin

 -- Albert Graef <Dr.Graef@t-online.de>  Wed, 21 Nov 2012 03:29:26 +0100

pure (0.56-3) natty; urgency=low

  * Make pure-texmacs package architecture-independent (it doesn't contain
    any binaries)

 -- Albert Graef <Dr.Graef@t-online.de>  Tue, 20 Nov 2012 12:23:39 +0100

pure (0.56-2) natty; urgency=low

  * Add pure-texmacs package

 -- Albert Graef <Dr.Graef@t-online.de>  Mon, 19 Nov 2012 21:08:32 +0100

pure (0.56-1) natty; urgency=low

  * New upstream release

 -- Albert Graef <Dr.Graef@t-online.de>  Mon, 19 Nov 2012 11:35:02 +0100

pure (0.55-3) natty; urgency=low

  * More fixes for Lucid compatibility: The stock llvm package has the
    tools in the wrong directory, so only use --with-tool-prefix if the
    directory actually exists.

 -- Albert Graef <Dr.Graef@t-online.de>  Mon, 11 Jun 2012 20:57:13 +0200

pure (0.55-2) natty; urgency=low

  * Fixes for Lucid compatibility: The Lucid llvm-dev package lacks a
    dependency on libffi-dev so we add this to the build dependencies of
    Pure instead.

 -- Albert Graef <Dr.Graef@t-online.de>  Wed, 06 Jun 2012 10:16:09 +0200

pure (0.55-1) natty; urgency=low

  * New upstream release

 -- Albert Graef <Dr.Graef@t-online.de>  Mon, 04 Jun 2012 13:01:14 +0200

pure (0.54-10) natty; urgency=low

  * Cleanup

 -- Albert Graef <Dr.Graef@t-online.de>  Sat, 02 Jun 2012 00:26:16 +0200

pure (0.54-9) natty; urgency=low

  * Move the standard library to the libpure package so that the
    environment needed to run source scripts is available even if the
    interpreter frontend is not installed.
  * Install the gedit and kate syntax highlighting files into the
    appropriate directories.

 -- Albert Graef <Dr.Graef@t-online.de>  Fri, 01 Jun 2012 22:20:53 +0200

pure (0.54-8) natty; urgency=low

  * Add gnumeric-pure to the pure-math dependencies

 -- Albert Graef <Dr.Graef@t-online.de>  Wed, 30 May 2012 22:08:21 +0200

pure (0.54-7) natty; urgency=low

  * Fix metapackage dependencies



=== debian/control ===
Source: pure
Section: devel
Priority: extra
Maintainer: Albert Graef <aggraef@gmail.com>
Build-Depends: debhelper (>= 7.0.50~), autotools-dev, bison, flex, llvm-3.5-dev,
 libgmp-dev, libmpfr-dev, libreadline-dev, emacs25-nox|emacs25|emacs24-nox|emacs24|emacs23-nox|emacs23, elpa-flycheck
Standards-Version: 3.9.5
Homepage: https://agraef.github.io/pure-lang
#Vcs-Git: git://git.debian.org/collab-maint/pure.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/pure.git;a=summary

Package: pure
Architecture: any
Depends: libpure8 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Suggests: pure-dev, pure-elisp, pure-docs
Description: Functional programming language based on term rewriting
 Pure is a modern-style functional programming language based on term
 rewriting. It offers equational definitions with pattern matching, full
 symbolic rewriting capabilities, dynamic typing, eager and lazy evaluation,
 lexical closures, built-in list and matrix support and an easy-to-use C
 interface. The interpreter uses LLVM as a backend to JIT-compile Pure
 programs to fast native code.
 .
 This package contains the interpreter frontend. We also recommend installing
 the pure-docs package which contains the online documentation, and the
 pure-elisp package if you'd like to do Pure development using the Emacs text
 editor. To enable some features such as batch compilation you'll also have to
 install the pure-dev package.

Package: libpure8
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Functional programming language based on term rewriting - runtime
 Pure is a modern-style functional programming language based on term
 rewriting. It offers equational definitions with pattern matching, full
 symbolic rewriting capabilities, dynamic typing, eager and lazy evaluation,
 lexical closures, built-in list and matrix support and an easy-to-use C
 interface. The interpreter uses LLVM as a backend to JIT-compile Pure
 programs to fast native code.
 .
 This package contains the Pure runtime and the standard Pure library. It is
 needed for all Pure development.

Package: pure-dev
Architecture: any
Depends: libpure8 (= ${binary:Version}), libgmp-dev, libmpfr-dev, llvm-3.5,
 pkg-config, ${misc:Depends}
Description: Functional programming language based on term rewriting - development files
 Pure is a modern-style functional programming language based on term
 rewriting. It offers equational definitions with pattern matching, full
 symbolic rewriting capabilities, dynamic typing, eager and lazy evaluation,
 lexical closures, built-in list and matrix support and an easy-to-use C
 interface. The interpreter uses LLVM as a backend to JIT-compile Pure
 programs to fast native code.
 .
 This package contains the development files (headers and libraries), which
 are needed for batch compilation of Pure programs and for developing addon
 modules. The batch compiler also requires the LLVM toolchain. Some examples
 distributed with Pure also require this package, so it is a good idea to
 install it anyway.

Package: pure-elisp
Architecture: any
Depends: emacs, elpa-flycheck, pure (= ${binary:Version}), ${misc:Depends}
Description: Functional programming language based on term rewriting - elisp files
 Pure is a modern-style functional programming language based on term
 rewriting. It offers equational definitions with pattern matching, full
 symbolic rewriting capabilities, dynamic typing, eager and lazy evaluation,
 lexical closures, built-in list and matrix support and an easy-to-use C
 interface. The interpreter uses LLVM as a backend to JIT-compile Pure
 programs to fast native code.
 .
 This package contains the Pure Emacs mode and Flycheck support.

Package: pure-texmacs
Architecture: all
Depends: pure (>= ${source:Version}), ${misc:Depends}
Description: Functional programming language based on term rewriting - texmacs plugin
 Pure is a modern-style functional programming language based on term
 rewriting. It offers equational definitions with pattern matching, full
 symbolic rewriting capabilities, dynamic typing, eager and lazy evaluation,
 lexical closures, built-in list and matrix support and an easy-to-use C
 interface. The interpreter uses LLVM as a backend to JIT-compile Pure
 programs to fast native code.
 .
 This package contains the Pure TeXmacs plugin and related files.

# Metapackages to pull in the various Pure-related packages.

Package: pure-base
Architecture: all
Depends: ${misc:Depends}, pure, pure-dev, pure-docs, pure-elisp
Description: Functional programming language based on term rewriting - base
 Pure is a modern-style functional programming language based on term
 rewriting. It offers equational definitions with pattern matching, full
 symbolic rewriting capabilities, dynamic typing, eager and lazy evaluation,
 lexical closures, built-in list and matrix support and an easy-to-use C
 interface. The interpreter uses LLVM as a backend to JIT-compile Pure
 programs to fast native code.
 .
 This is a dependency package which provides the basic parts of the Pure
 system (interpreter, runtime, standard library, development files, Emacs mode
 and the online documentation), i.e., everything that's needed for basic Pure
 development.

Package: pure-util
Architecture: all
Depends: ${misc:Depends}, pure-avahi, pure-doc, pure-gen, pure-ffi,
 pure-readline, pure-sockets, pure-stldict, pure-stllib
Description: Functional programming language based on term rewriting - basic libraries and utilities
 Pure is a modern-style functional programming language based on term
 rewriting. It offers equational definitions with pattern matching, full
 symbolic rewriting capabilities, dynamic typing, eager and lazy evaluation,
 lexical closures, built-in list and matrix support and an easy-to-use C
 interface. The interpreter uses LLVM as a backend to JIT-compile Pure
 programs to fast native code.
 .
 This is a dependency package which provides basic support utilities and
 libraries. At the time of this writing, this comprises the pure-doc and
 pure-gen utilities, as well as the avahi, ffi, readline, sockets and STL
 container interfaces.

# NOTE: The gnumeric-pure package isn't included in pure-math for now due to
# lack of required libspreadsheet development files. This should supposedly
# be fixed in newer versions (>= 1.12.16) of the Debian Gnumeric package, cf.
# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=723903, but the version
# available in 14.04 LTS is 1.12.9 which is too old. So, for the time being
# users who need this package will have to build it from source.

Package: pure-math
Architecture: all
Depends: ${misc:Depends}, pure-glpk, pure-gplot, pure-gsl, pure-mpfr,
 pure-octave, pure-rational, pure-reduce, pure-texmacs
Description: Functional programming language based on term rewriting - scientific programming
 Pure is a modern-style functional programming language based on term
 rewriting. It offers equational definitions with pattern matching, full
 symbolic rewriting capabilities, dynamic typing, eager and lazy evaluation,
 lexical closures, built-in list and matrix support and an easy-to-use C
 interface. The interpreter uses LLVM as a backend to JIT-compile Pure
 programs to fast native code.
 .
 This is a dependency package which provides the interfaces to various 3rd
 party mathematical software (GLPK, GSL, MPFR, Octave, Gnuplot). It also
 includes the Pure TeXmacs plugin and Jiri Spitz' Pure port of Rob Hubbard's
 rational number library.

Package: pure-web
Architecture: all
Depends: ${misc:Depends}, pure-csv, pure-fastcgi, pure-odbc, pure-sql3,
 pure-xml
Description: Functional programming language based on term rewriting - database and web programming
 Pure is a modern-style functional programming language based on term
 rewriting. It offers equational definitions with pattern matching, full
 symbolic rewriting capabilities, dynamic typing, eager and lazy evaluation,
 lexical closures, built-in list and matrix support and an easy-to-use C
 interface. The interpreter uses LLVM as a backend to JIT-compile Pure
 programs to fast native code.
 .
 This is a dependency package which provides the interfaces for database and
 web programming (CSV, ODBC, SQLite3, FastCGI, XML).

Package: pure-graphics
Architecture: all
Depends: ${misc:Depends}, pure-g2, pure-gl, pure-gtk, pure-tk
Description: Functional programming language based on term rewriting - GUI and graphics programming
 Pure is a modern-style functional programming language based on term
 rewriting. It offers equational definitions with pattern matching, full
 symbolic rewriting capabilities, dynamic typing, eager and lazy evaluation,
 lexical closures, built-in list and matrix support and an easy-to-use C
 interface. The interpreter uses LLVM as a backend to JIT-compile Pure
 programs to fast native code.
 .
 This is a dependency package which provides the interfaces for GUI and
 graphics programming (G2, OpenGL, GTK+, Tcl/Tk).

Package: pure-multimedia
Architecture: all
Depends: ${misc:Depends}, faust2pd, faust2pd-extra, pd-faust, pd-pure,
 pure-audio, pure-liblo, pure-lilv, pure-lv2, pure-midi, pure-faust
Description: Functional programming language based on term rewriting - multimedia programming
 Pure is a modern-style functional programming language based on term
 rewriting. It offers equational definitions with pattern matching, full
 symbolic rewriting capabilities, dynamic typing, eager and lazy evaluation,
 lexical closures, built-in list and matrix support and an easy-to-use C
 interface. The interpreter uses LLVM as a backend to JIT-compile Pure
 programs to fast native code.
 .
 This is a dependency package which provides Pure's multimedia library, which
 covers the audio, LV2, OSC and MIDI interfaces, as well as utilities and
 libraries for interfacing with Faust and Pd (Pure Data).

Package: pure-complete
Architecture: all
Depends: ${misc:Depends}, pure-base, pure-util, pure-math, pure-web,
 pure-graphics, pure-multimedia
Description: Functional programming language based on term rewriting - the full environment
 Pure is a modern-style functional programming language based on term
 rewriting. It offers equational definitions with pattern matching, full
 symbolic rewriting capabilities, dynamic typing, eager and lazy evaluation,
 lexical closures, built-in list and matrix support and an easy-to-use C
 interface. The interpreter uses LLVM as a backend to JIT-compile Pure
 programs to fast native code.
 .
 This is a dependency package which provides the complete Pure programming
 environment including all available addon modules.
